#include "adc.h"








void ADC_ChInit(ADC_TypeDef * ADCx, _Bool temp)
{

	ADC_InitTypeDef adcInitStruct;
	
	if(ADCx == ADC1)
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);
	else if(ADCx == ADC2)
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC2, ENABLE);
	else
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC3, ENABLE);
	
	RCC_ADCCLKConfig(RCC_PCLK2_Div6); //ADCƵ6 72M/6=12,ADCʱ䲻ܳ14M
	
	ADC_DeInit(ADCx); //λADCx, ADCx ȫĴΪȱʡֵ
	
	adcInitStruct.ADC_ContinuousConvMode = DISABLE; //ģתڵתģʽ
	adcInitStruct.ADC_DataAlign = ADC_DataAlign_Right; //ADCҶ
	adcInitStruct.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תⲿ
	adcInitStruct.ADC_Mode = ADC_Mode_Independent; //ADCģʽ:ADC1ADC2ڶģʽ
	adcInitStruct.ADC_NbrOfChannel = 1; //˳йתADCͨĿ
	adcInitStruct.ADC_ScanConvMode = DISABLE; //ģתڵͨģʽ
	ADC_Init(ADCx, &adcInitStruct);	//adcInitStructָĲʼADCxļĴ
	
	if(ADCx == ADC1 && temp)
		ADC_TempSensorVrefintCmd(ENABLE); //ڲ¶ȴ//ADC1ͨ16
	
	ADC_Cmd(ADCx, ENABLE); //ʹָADC1
	
	ADC_ResetCalibration(ADCx);	//ʹܸλУ׼  
	 
	while(ADC_GetResetCalibrationStatus(ADCx));	//ȴλУ׼
	
	ADC_StartCalibration(ADCx); //ADУ׼
 
	while(ADC_GetCalibrationStatus(ADCx)); //ȴУ׼

}

unsigned short ADC_GetValue(ADC_TypeDef * ADCx, unsigned char ch)
{

	//ָADCĹͨһУʱ
	ADC_RegularChannelConfig(ADCx, ch, 1, ADC_SampleTime_239Cycles5 );	//ADC1,ADCͨ,ʱΪ239.5	  			    
  
	ADC_SoftwareStartConvCmd(ADCx, ENABLE);		//ʹָADC1ת
	 
	while(!ADC_GetFlagStatus(ADCx, ADC_FLAG_EOC )); //ȴת

	return ADC_GetConversionValue(ADCx);	//һADC1ת

}

float ADC_GetValueTimes(ADC_TypeDef * ADCx, unsigned char ch, unsigned char times)
{

	float adcValue = 0;
	unsigned char i = 0;
	
	for(; i < times; i++)
	{
		adcValue += (float)ADC_GetValue(ADC1, ch);
	}
	
	return adcValue / times;

}

float ADC_GetTemperature(void)
{

	float temp = ADC_GetValueTimes(ADC1, ADC_Channel_16, 10); //ȡԭʼAD
	
	temp = temp * 3.3 / 4096; //תΪѹֵ
	
	return (1.43 - temp) / 0.0043 + 25; //ǰ¶ֵ

}
