/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	AT24C02.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-01-19
	*
	*	汾 		V1.1
	*
	*	˵ 		EEPROM
	*
	*	޸ļ¼	V1.1޸ʱдbug
	************************************************************
	************************************************************
	************************************************************
**/

//Ӳ
#include "at24c02.h"
#include "i2c.h"
#include "delay.h"
#include "hwtimer.h"




/*
************************************************************
*	ƣ	AT24C02_WriteByte
*
*	ܣ	дһֽڵEEPROM
*
*	ڲ	regAddrĴַ
*				byteҪд
*
*	ز	
*
*	˵		
************************************************************
*/
void AT24C02_WriteByte(unsigned char regAddr, unsigned char byte)
{

	I2C_WriteByte(AT24C02_ADDRESS, regAddr, &byte);

}

/*
************************************************************
*	ƣ	AT24C02_WriteBytes
*
*	ܣ	дֽڵEEPROM
*
*	ڲ	regAddrĴַ
*				byteҪдݻ
*				lenݳ
*
*	ز	
*
*	˵		
************************************************************
*/
void AT24C02_WriteBytes(unsigned char regAddr, unsigned char *byte, unsigned char len)
{
	
	unsigned char count = 0;
	
	RTOS_ENTER_CRITICAL();									//дʱٽΣôϳ
	
	for(; count < len;)
	{
		if(I2C_WriteByte(AT24C02_ADDRESS, regAddr, byte) == IIC_Err)
		{
			DelayXms(5);
			continue;
		}
		
		regAddr++;											//ַ
		byte++;												//ƫƵ¸
		count++;
		
		DelayXms(5);										//Ҫʱһˣʮֽʱ1msʱʱ޷֤ȫֽȷд
	}
	
	RTOS_EXIT_CRITICAL();

}

/*
************************************************************
*	ƣ	AT24C02_ReadByte
*
*	ܣ	EEPROMһֽ
*
*	ڲ	regAddrĴַ
*				byteҪȡݵĻַ
*
*	ز	
*
*	˵		
************************************************************
*/
void AT24C02_ReadByte(unsigned char regAddr, unsigned char *byte)
{

	I2C_ReadByte(AT24C02_ADDRESS, regAddr, byte);

}

/*
************************************************************
*	ƣ	AT24C02_ReadBytes
*
*	ܣ	EEPROMֽ
*
*	ڲ	regAddrĴַ
*				byteҪдݻ
*				lenݳ
*
*	ز	
*
*	˵		
************************************************************
*/
void AT24C02_ReadBytes(unsigned char regAddr, unsigned char *byte, unsigned char len)
{
	
	RTOS_ENTER_CRITICAL();									//ȡʱٽΣôϳ

	I2C_ReadBytes(AT24C02_ADDRESS, regAddr, byte, len);
	
	RTOS_EXIT_CRITICAL();

}

/*
************************************************************
*	ƣ	AT24C02_Clear
*
*	ܣ	ַָʼдͬ
*
*	ڲ	startAddrĴʼַ
*				byteҪд
*				lenݳ
*
*	ز	
*
*	˵		дָλָȵָ
************************************************************
*/
_Bool AT24C02_Clear(unsigned char startAddr, unsigned char byte, unsigned short len)
{
	
	unsigned short count = 0;

	if(startAddr + len > 256)									//
		return 1;
	
	RTOS_ENTER_CRITICAL();										//дʱٽΣôϳ
	
	for(; count < len;)
	{
		if(I2C_WriteByte(AT24C02_ADDRESS, startAddr, &byte) == IIC_Err)
		{
			DelayXms(5);
			continue;
		}
		
		startAddr++;											//ַ
		count++;
		
		DelayXms(5);											//Ҫʱһˣʮֽʱ1msʱʱ޷֤ȫֽȷд
	}
	
	RTOS_EXIT_CRITICAL();
	
	return 0;

}
