/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	main.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-01-23
	*
	*	汾 		V1.0
	*
	*	˵ 		ɵƬʼICʼĴ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//OS
#include "FreeRTOS.h"
#include "task.h"
#include "timers.h"
#include "freertosAPI.h"

//豸
#include "net_device.h"

//Э
#include "onenet.h"
#include "fault.h"

//
#include "ZW_DataStream.h"

//Ӳ
#include "led.h"
#include "delay.h"
#include "key.h"
#include "lcd1602.h"
#include "usart.h"
#include "hwtimer.h"
#include "i2c.h"
#include "gy30.h"
#include "adxl345.h"
#include "sht20.h"
#include "iwdg.h"
#include "stmflash.h"
#include "at24c02.h"
#include "selfcheck.h"
#include "beep.h"
#include "oled.h"
#include "info.h"
#include "tcrt5000.h"

//C
#include <string.h>






//Ź
#define IWDG_TASK_PRIO		11
#define IWDG_STK_SIZE		64
TaskHandle_t IWDG_Task_Handler;
void IWDG_Task(void *pvParameters);

//
#define USART_TASK_PRIO		10
#define USART_STK_SIZE		256
TaskHandle_t USART_Task_Handler;
void USART_Task(void *pvParameters);

//
#define HEART_TASK_PRIO		9
#define HEART_STK_SIZE		256
TaskHandle_t HEART_Task_Handler;
void HEART_Task(void *pvParameters);

//ϴ
#define FAULT_TASK_PRIO		8 //
#define FAULT_STK_SIZE		256
TaskHandle_t FAULT_Task_Handler;
void FAULT_Task(void *pvParameters);

//
#define SENSOR_TASK_PRIO	7
#define SENSOR_STK_SIZE		256
TaskHandle_t SENSOR_Task_Handler;
void SENSOR_Task(void *pvParameters);

//ݷ
#define SEND_TASK_PRIO		6
#define SEND_STK_SIZE		512
TaskHandle_t SEND_Task_Handler;
void SEND_Task(void *pvParameters);

//
#define KEY_TASK_PRIO		5
#define KEY_STK_SIZE		128
TaskHandle_t KEY_Task_Handler;
void KEY_Task(void *pvParameters);

//ʼ
#define NET_TASK_PRIO		4 //
#define NET_STK_SIZE		512
TaskHandle_t NET_Task_Handler;
void NET_Task(void *pvParameters);

//ݷ
#define DATA_TASK_PRIO		3 //
#define DATA_STK_SIZE		512
TaskHandle_t DATA_Task_Handler;
void DATA_Task(void *pvParameters);

//Ϣ
#define ALTER_TASK_PRIO		2 //
#define ALTER_STK_SIZE		128
TaskHandle_t ALTER_Task_Handler;
void ALTER_Task(void *pvParameters);



#define NET_TIME	60			//趨ʱ--λ
unsigned short timerCount = 0;	//ʱ--λ

TimerHandle_t t1_Thdl;

//
DATA_STREAM dataStream[] = {
								{ZW_REDLED, &ledStatus.Led4Sta, TYPE_BOOL, 1},
								{ZW_GREENLED, &ledStatus.Led5Sta, TYPE_BOOL, 1},
								{ZW_YELLOWLED, &ledStatus.Led6Sta, TYPE_BOOL, 1},
								{ZW_BLUELED, &ledStatus.Led7Sta, TYPE_BOOL, 1},
								{ZW_BEEP, &beepInfo.Beep_Status, TYPE_BOOL, 1},
								{ZW_WENDU, &sht20Info.tempreture, TYPE_FLOAT, 1},
								{ZW_SHIDU, &sht20Info.humidity, TYPE_FLOAT, 1},
								{ZW_XG, &adxlInfo.incidence_Xf, TYPE_FLOAT, 1},
								{ZW_YG, &adxlInfo.incidence_Yf, TYPE_FLOAT, 1},
								{ZW_ZG, &adxlInfo.incidence_Zf, TYPE_FLOAT, 1},
								{ZW_ERRTYPE, &faultTypeReport, TYPE_UCHAR, 1},
							};
unsigned char dataStreamLen = sizeof(dataStream) / sizeof(dataStream[0]);



/*
************************************************************
*	ƣ	Hardware_Init
*
*	ܣ	Ӳʼ
*
*	ڲ	
*
*	ز	
*
*	˵		ʼƬԼ豸
************************************************************
*/
void Hardware_Init(void)
{
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);								//жϿ

	Delay_Init();																//Timer6ʼ
	
	Led_Init();																	//LEDʼ
	
	Key_Init();																	//ʼ
	
	Beep_Init();																//ʼ
	
	TCRT5000_Init();															//TCRT5000ʼ
	
	IIC_Init();																	//IIC߳ʼ
	
	Lcd1602_Init();																//LCD1602ʼ
	
	Usart1_Init(115200); 														//ʼ   115200bps
	
	Lcd1602_DisString(0x80, "Check Power On");									//ʾп
	Check_PowerOn(); 															//ϵԼ
	Lcd1602_Clear(0x80);														//һʾ
	
	if(checkInfo.ADXL345_OK == DEV_OK) 											//⵽ADXL345ʼ
		ADXL345_Init();
	
	if(checkInfo.OLED_OK == DEV_OK)												//⵽OLEDʼ
	{
		OLED_Init();
	}

	if(RCC_GetFlagStatus(RCC_FLAG_IWDGRST) == SET) 								//ǿŹλʾ
	{
		UsartPrintf(USART_DEBUG, "WARN:	IWDG Reboot\r\n");
		
		RCC_ClearFlag();														//Źλ־λ
		
		faultTypeReport = faultType = FAULT_REBOOT; 							//Ϊ
		
		netDeviceInfo.reboot = 1;
		
		if(!Info_Check() && checkInfo.EEPROM_OK)								//EEPROMϢ
			Info_Read();
	}
	else
	{
		//ȶssidpswddevidapikey
		if(!Info_Check() && checkInfo.EEPROM_OK)								//EEPROMϢ
		{
			//AT24C02_Clear(0, 255, 256);Iwdg_Feed();
			UsartPrintf(USART_DEBUG, "1.ssid_pswd in EEPROM\r\n");
			Info_Read();
		}
		else //û
		{
			UsartPrintf(USART_DEBUG, "1.ssid_pswd in ROM\r\n");
		}
		
		UsartPrintf(USART_DEBUG, "2.DEVID: %s,     APIKEY: %s\r\n"
								, oneNetInfo.devID, oneNetInfo.apiKey);
		
		netDeviceInfo.reboot = 0;
	}
	
	Iwdg_Init(4, 1250); 														//64Ƶÿ625Σ1250Σ2s
	
	UsartPrintf(USART_DEBUG, "3.Hardware init OK\r\n");							//ʾʼ

}

/*
************************************************************
*	ƣ	OS_TimerCallBack
*
*	ܣ	ʱ״̬־λ
*
*	ڲ	ʱ
*
*	ز	
*
*	˵		ʱ񡣶ʱ״̬趨ʱӣƽ̨
************************************************************
*/
void OS_TimerCallBack(TimerHandle_t xTimer)
{
	
	if(oneNetInfo.netWork == 0)											//Ͽ
	{
		if(++timerCount >= NET_TIME) 									//Ͽʱ
		{
			UsartPrintf(USART_DEBUG, "Tips:		Timer Check Err\r\n");
			
			checkInfo.NET_DEVICE_OK = 0;								//豸δ־
			
			NET_DEVICE_ReConfig(0);										//豸ʼΪʼ״̬
			
			oneNetInfo.netWork = 0;
		}
	}
	else
	{
		timerCount = 0;													//
	}

}

/*
************************************************************
*	ƣ	main
*
*	ܣ	ɳʼ񣬴Ӧִ
*
*	ڲ	
*
*	ز	0
*
*	˵		
************************************************************
*/
int main(void)
{
	
	Hardware_Init();								//Ӳʼ
	
	//Ӧ
	
	xTaskCreate((TaskFunction_t)IWDG_Task, "IWDG", IWDG_STK_SIZE, NULL, IWDG_TASK_PRIO, (TaskHandle_t*)&IWDG_Task_Handler);
	
	xTaskCreate((TaskFunction_t)USART_Task, "USART", USART_STK_SIZE, NULL, USART_TASK_PRIO, (TaskHandle_t*)&USART_Task_Handler);
	
	xTaskCreate((TaskFunction_t)HEART_Task, "HEART", HEART_STK_SIZE, NULL, HEART_TASK_PRIO, (TaskHandle_t*)&HEART_Task_Handler);
	
	xTaskCreate((TaskFunction_t)FAULT_Task, "FAULT", FAULT_STK_SIZE, NULL, FAULT_TASK_PRIO, (TaskHandle_t*)&FAULT_Task_Handler);
	
	xTaskCreate((TaskFunction_t)SENSOR_Task, "SENSOR", SENSOR_STK_SIZE, NULL, SENSOR_TASK_PRIO, (TaskHandle_t*)&SENSOR_Task_Handler);
	
	xTaskCreate((TaskFunction_t)SEND_Task, "SEND", SEND_STK_SIZE, NULL, SEND_TASK_PRIO, (TaskHandle_t*)&SEND_Task_Handler);
	
	xTaskCreate((TaskFunction_t)KEY_Task, "KEY", KEY_STK_SIZE, NULL, KEY_TASK_PRIO, (TaskHandle_t*)&KEY_Task_Handler);
	
	xTaskCreate((TaskFunction_t)NET_Task, "NET", NET_STK_SIZE, NULL, NET_TASK_PRIO, (TaskHandle_t*)&NET_Task_Handler);
	
	xTaskCreate((TaskFunction_t)DATA_Task, "DATA", DATA_STK_SIZE, NULL, DATA_TASK_PRIO, (TaskHandle_t*)&DATA_Task_Handler);
	
	xTaskCreate((TaskFunction_t)ALTER_Task, "ALTER", ALTER_STK_SIZE, NULL, ALTER_TASK_PRIO, (TaskHandle_t*)&ALTER_Task_Handler);
	
	t1_Thdl = xTimerCreate("Timer1", 200, pdTRUE, (void *)1, (TimerCallbackFunction_t)OS_TimerCallBack);
	xTimerStart(t1_Thdl, 1);
	
	Lcd1602_Clear(0xff);							//
	
	UsartPrintf(USART_DEBUG, "4.OSStart\r\n");		//ʾʼִ
	
	vTaskStartScheduler();							//ʼ
	
	return 0;

}

/*
************************************************************
*	ƣ	IWDG_Task
*
*	ܣ	Ź
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		Ź
************************************************************
*/
void IWDG_Task(void *pvParameters)
{

	while(1)
	{
	
		Iwdg_Feed(); 		//ι
		
		RTOS_TimeDly(50); 	//250ms
	
	}

}

/*
************************************************************
*	ƣ	KEY_Task
*
*	ܣ	ɨ谴Ƿ£а£жӦĴ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		
************************************************************
*/
void KEY_Task(void *pvParameters)
{

	while(1)
	{
		
		switch(Keyboard())								//ɨ谴״̬
		{
			case KEY0DOWN:								//key0¼
				
				if(ledStatus.Led4Sta == LED_OFF)
					Led4_Set(LED_ON);
				else
					Led4_Set(LED_OFF);
				
				oneNetInfo.sendData = 1;				//ݷ
			
			break;
			
			case KEY2DOWN:
				
				if(ledStatus.Led5Sta == LED_OFF)
					Led5_Set(LED_ON);
				else
					Led5_Set(LED_OFF);
			
				oneNetInfo.sendData = 1;
				
			break;
			
			case KEY3DOWN:
				
				if(ledStatus.Led6Sta == LED_OFF)
					Led6_Set(LED_ON);
				else
					Led6_Set(LED_OFF);
			
				oneNetInfo.sendData = 1;
				
			break;
			
			case KEY1DOWN:
				
				if(ledStatus.Led7Sta == LED_OFF)
					Led7_Set(LED_ON);
				else
					Led7_Set(LED_OFF);
				
				oneNetInfo.sendData = 1;
				
			break;
				
			case KEY0DOWNLONG:
				
				
			
			break;
			
			case KEY2DOWNLONG:
				
				Usart_SendString(USART2,
						(unsigned char *)"abcd", 4); 	//ģЭ
			
			break;
			
			case KEY3DOWNLONG:
				
				//OneNet_PushData("3987010", "{redled}1", strlen("{redled}1")); //kylin-v2.1
				//OneNet_PushData("4091363", "{redled}1", strlen("{redled}1")); //kylin-v2.2
				OneNet_PushData("4089178", "{redled}1", strlen("{redled}1")); //Mini-V1.1
			
			break;
			
			case KEY3DOUBLE:
				
				//OneNet_PushData("3987010", "{redled}0", strlen("{redled}0")); //kylin-v2.1
				//OneNet_PushData("4091363", "{redled}0", strlen("{redled}0")); //kylin-v2.2
				OneNet_PushData("4089178", "{redled}0", strlen("{redled}0")); //Mini-V1.1
			
			break;
			
			default:
			break;
		}
	
		RTOS_TimeDly(10); 								//50ms
	
	}

}

/*
************************************************************
*	ƣ	HEART_Task
*
*	ܣ	
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		񡣷󲢵ȴӦ趨ʱûӦƽ̨
************************************************************
*/
void HEART_Task(void *pvParameters)
{

	while(1)
	{
		
		OneNet_HeartBeat();				//
		
		RTOS_TimeDly(4000);				//20s
	
	}

}

/*
************************************************************
*	ƣ	SEND_Task
*
*	ܣ	ϴ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ݷ
************************************************************
*/
void SEND_Task(void *pvParameters)
{
	
	while(1)
	{
		
		OneNet_SendData(kTypeSimpleJsonWithoutTime, dataStreamLen);	//ϴݵƽ̨
		
		RTOS_TimeDly(3000);											//15s
		
	}

}

/*
************************************************************
*	ƣ	USART_Task
*
*	ܣ	ƽ̨·
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ڽģʽʱȴƽ̨·
************************************************************
*/
void USART_Task(void *pvParameters)
{
	
	unsigned char *dataPtr;														//ָ

	while(1)
	{
		if(oneNetInfo.netWork && NET_DEVICE_Get_DataMode() == DEVICE_DATA_MODE)	//  ģʽʱ
		{
			dataPtr = NET_DEVICE_GetIPD(0);										//ȴȡƽ̨·
			if(dataPtr != NULL)													//ָ벻Ϊգյ
			{
				OneNet_App(dataPtr);											//д
			}
		}
		
		RTOS_TimeDly(2);														//10ms
	
	}

}

/*
************************************************************
*	ƣ	SENSOR_Task
*
*	ܣ	ݲɼʾ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ݲɼ񡣽Ӵݲɼȡʾ
************************************************************
*/
void SENSOR_Task(void *pvParameters)
{
	
	OLED_ClearScreen();											//
	
	//ʾ
	OLED_DisChar16x16(0, 0, san);								//ʾ
	OLED_DisChar16x16(0, 16, zhou);								//ʾᡱ
	OLED_DisString6x8(1, 32, ":");								//ʾ
	
	OLED_DisChar16x16(2, 0, wen);								//ʾ¡
	OLED_DisChar16x16(2, 16, shi);								//ʾʪ
	OLED_DisChar16x16(2, 32, du);								//ʾȡ
	OLED_DisString6x8(3, 48, ":");								//ʾ
	
	OLED_DisChar16x16(6, 0, zhuang);							//ʾ״
	OLED_DisChar16x16(6, 16, tai);								//ʾ̬
	OLED_DisString6x8(7, 32, ":");								//ʾ

	while(1)
	{
		
		if(checkInfo.ADXL345_OK == DEV_OK) 						//ֻ豸ʱŻȡֵʾ
		{
			ADXL345_GetValue();									//ɼ
			Lcd1602_DisString(0x80, "X%0.1f,Y%0.1f,Z%0.1f", adxlInfo.incidence_Xf, adxlInfo.incidence_Yf, adxlInfo.incidence_Zf);
			OLED_DisString6x8(1, 40, "X%0.1f,Y%0.1f,Z%0.1f", adxlInfo.incidence_Xf, adxlInfo.incidence_Yf, adxlInfo.incidence_Zf);
		}
		if(checkInfo.SHT20_OK == DEV_OK) 						//ֻ豸ʱŻȡֵʾ
		{
			SHT20_GetValue();									//ɼ
			Lcd1602_DisString(0xC0, "%0.1fC,%0.1f%%", sht20Info.tempreture, sht20Info.humidity);
			OLED_DisString6x8(3, 56, "%0.1fC,%0.1f%%", sht20Info.tempreture, sht20Info.humidity);
		}
		
		if(t5000Info.status == TCRT5000_ON)
		{
			TCRT5000_GetValue(5);
			if(t5000Info.voltag < 3500)
				Beep_Set(BEEP_ON);
			else
				Beep_Set(BEEP_OFF);
		}
		
		RTOS_TimeDly(100); 										//500ms
	
	}

}

/*
************************************************************
*	ƣ	DATA_Task
*
*	ܣ	ƽ̨·ݷ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ݷƽ̨·ָķ͸ģʽʱյ֮أ͸ģʽΪҪ'>'ţʹķʽ
************************************************************
*/
void DATA_Task(void *pvParameters)
{

	while(1)
	{
	
		if(oneNetInfo.sendData == 1)		//ݷ־λ
		{
			oneNetInfo.sendData = OneNet_SendData(kTypeSimpleJsonWithoutTime, dataStreamLen);	//ϴݵƽ̨
		}
		
		RTOS_TimeDly(10);					//50ms
	
	}

}

/*
************************************************************
*	ƣ	FAULT_Task
*
*	ܣ	״̬
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ϴ񡣵豸ʱǶӦ־λȻнд
************************************************************
*/
void FAULT_Task(void *pvParameters)
{

	while(1)
	{
		
		if(faultType != FAULT_NONE)									//־
		{
			UsartPrintf(USART_DEBUG, "WARN:	Fault Process\r\n");
			Fault_Process();										//
		}
		
		RTOS_TimeDly(10);											//50ms
	
	}

}

/*
************************************************************
*	ƣ	NET_Task
*
*	ܣ	ӡƽ̨
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		񡣻߼״̬д״̬Ȼ
************************************************************
*/
void NET_Task(void *pvParameters)
{
	
	NET_DEVICE_IO_Init();													//豸IOʼ
	NET_DEVICE_Reset();														//豸λ
	NET_DEVICE_Set_DataMode(DEVICE_CMD_MODE);								//Ϊշģʽ(ESP8266ҪATķػƽ̨·ݵķ)

	while(1)
	{
		
		if(!oneNetInfo.netWork && (checkInfo.NET_DEVICE_OK == DEV_OK))		//û  ģ⵽ʱ
		{
			OLED_DisChar16x16(6, 48, lian);
			OLED_DisChar16x16(6, 64, jie);
			OLED_DisChar16x16(6, 80, zhong);
			NET_DEVICE_Set_DataMode(DEVICE_CMD_MODE);						//Ϊշģʽ
			
			if(!NET_DEVICE_Init(oneNetInfo.ip, oneNetInfo.port))			//ʼ豸
			{
				OneNet_DevLink(oneNetInfo.devID, oneNetInfo.apiKey);		//ƽ̨
				
				if(oneNetInfo.netWork)
				{
					Beep_Set(BEEP_ON);										//̽ʾɹ
					RTOS_TimeDly(40);
					Beep_Set(BEEP_OFF);
							
					OLED_DisChar16x16(6, 48, yi);
					OLED_DisChar16x16(6, 64, lian);
					OLED_DisChar16x16(6, 80, jie);
				}
				else
				{
					Beep_Set(BEEP_ON);										//ʾʧ
					RTOS_TimeDly(100);
					Beep_Set(BEEP_OFF);
					
					OLED_DisChar16x16(6, 48, wei);
					OLED_DisChar16x16(6, 64, lian);
					OLED_DisChar16x16(6, 80, jie);
				}
			}
		}
		
		if(checkInfo.NET_DEVICE_OK == DEV_ERR) 								//豸δ
		{
			NET_DEVICE_Set_DataMode(DEVICE_CMD_MODE);						//Ϊշģʽ
			
			if(timerCount >= NET_TIME) 										//ӳʱ
			{
				NET_DEVICE_Reset();											//λ豸
				timerCount = 0;												//ӳʱ
				faultType = FAULT_NONE;										//־
			}
			
			if(!NET_DEVICE_Exist())											//豸
			{
				UsartPrintf(USART_DEBUG, "NET Device :Ok\r\n");
				checkInfo.NET_DEVICE_OK = DEV_OK;							//⵽豸
				NET_DEVICE_Set_DataMode(DEVICE_DATA_MODE);					//Ϊշģʽ
			}
			else
				UsartPrintf(USART_DEBUG, "NET Device :Error\r\n");
		}
		
		RTOS_TimeDly(5);													//25ms
	
	}

}

/*
************************************************************
*	ƣ	ALTER_Task
*
*	ܣ	ͨڸSSIDPSWDDEVIDAPIKEY
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ĺᱣ浽EEPROM
************************************************************
*/
void ALTER_Task(void *pvParameters)
{
    
    unsigned char usart1Count = 0;

    while(1)
    {
    
        memset(alterInfo.alterBuf, 0, sizeof(alterInfo.alterBuf));
		alterInfo.alterCount = 0;usart1Count = 0;
        while((strlen(alterInfo.alterBuf) != usart1Count) || (usart1Count == 0))	//ȴ
        {
            usart1Count = strlen(alterInfo.alterBuf);								//㳤
            RTOS_TimeDly(20);														//ÿ100msһ
        }
        UsartPrintf(USART_DEBUG, "\r\nusart1Buf Len: %d, usart1Count = %d\r\n",
									strlen(alterInfo.alterBuf), usart1Count);
        
		if(checkInfo.EEPROM_OK == DEV_OK)											//EEPROM
		{
			if(Info_Alter(alterInfo.alterBuf))										//Ϣ
			{
				Info_Read();
				
				if(oneNetInfo.netWork)
				{
					NET_DEVICE_ReLink(oneNetInfo.ip, oneNetInfo.port);				//ƽ̨
					oneNetInfo.netWork = 0;											//ƽ̨
				}
			}
		}
    
    }

}
